<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreatePackingMaterialChecklistHeadersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('qc_packing_material_checklist_headers', function (Blueprint $table) {
            $table->id('packing_material_id');
            $table->integer('user_id');
            $table->string('reference_no');
            $table->date('date');
            $table->integer('factory');
            $table->string('supplier_name');
            $table->boolean('strapping_rolls')->default(false);
            $table->boolean('clips')->default(false);
            $table->boolean('film_rolls')->default(false);
            $table->boolean('carton_pack')->default(false);
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('qc_packing_material_checklist_headers');
    }
}
