<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;

class PackingLineQualityRecordHeader extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_packing_line_quality_record_headers';
    protected $primaryKey = 'plqr_id';
    protected $fillable = [];

    protected static $logAttributes = [
        'plqr_id',
        'trans_date',
        'customer_order_plan_data_id'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_packing_line_quality_record_headers";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}