<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class PallatizingDetailsData extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_pallatizing_details_data';
    protected $primaryKey = 'pallatizing_data_id';
    protected $fillable = [];

    protected static $logAttributes = [
        'pallatizing_data_id',
        'pallatizing_id',
        'pallatize_date',
        'rcl_no',
        'l1_qty',
        'l2_qty',
        'l3_qty',
        'l4_qty',
        'l5_qty',
        'l6_qty',
        'l7_qty',
        'l8_qty',
        'l9_qty',
        'l10_qty',
        'l11_qty',
        'l12_qty',
        'l13_qty',
        'width',
        'length',
        'height',
        'weight',
        'label_no'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_pallatizing_details_data";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}