<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class ProductionWeightReportHeader extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_production_weight_report_headers';
    protected $primaryKey = 'pwr_id';
    protected $fillable = [];

    protected static $logAttributes = [
        'pwr_id',
        'user_id',
        'reference_no',
        'date',
        'customer_order_plan_data_id',
        'factory'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_production_weight_report_headers";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}