<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class SampleInformationAttachment extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_sample_information_attachments';
    protected $primaryKey = 'sample_information_attachment_id';
    protected $fillable = [];


    protected static $logAttributes = [
        'sample_information_attachment_id',
        'sample_information_id',
        'path',
        'token'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_sample_information_attachments";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}