<?php

namespace Modules\Qc\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;


class SupervisorCheckListHeader extends Model
{
    use HasFactory, LogsActivity;

    protected $table = 'qc_supervisor_check_list_headers';
    protected $primaryKey = 'scl_id';
    protected $fillable = [];

    protected static $logAttributes = [
        'scl_id',
        'reference_no',
        'shift_id',
        'factory',
        'customer_order_plan_data_id',
        'date'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "qc_supervisor_check_list_headers";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}