var TOKEN = Date.now().toString();
var scale_calibration_id = null;

$(document).ready(function () {
    $("#myTable").DataTable({
        scrollX: true,
        order: [],
        columns: [
            { data: "Reference No" },
            { data: "Factory" },
            { data: "Description" },
            { data: "Date" },
            { data: "edit", className: "edit", orderable: false },
            { data: "view", className: "view", orderable: false },
            { data: "delete", className: "delete", orderable: false },
        ],
        columnDefs: [
            { width: 30, targets: 4 },
            { width: 30, targets: 5 },
            { width: 30, targets: 6},
        ],
    });

    $("#attachment_token").val(TOKEN);

    allScaleCalibrationRecords();
    getFactoryData();

    $("#btnAttachment").on("click", function () {
        $("#attachmentAddModal").modal("toggle");
    });

    $("#btnModalSave").on("click", function () {
        if ($(this).text() === "Save") {
            saveScaleCalibrationRecord();
        } else {
            updateScaleCalibrationRecord(scale_calibration_id);
        }
    });
});

Dropzone.options.myDropzone = {
    dictDefaultMessage: "Drop file here or click to upload!!!!!!!!",
    addRemoveLinks: true,
    maxFiles: 1,
    init: function () {
        var dropzone = this;
        clearDropzone = function () {
            dropzone.removeAllFiles(true);
        };
    },
};

function allScaleCalibrationRecords() {
    $.ajax({
        type: "GET",
        url: "/qc/ScaleCalibrationController/records",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            if (response.data.success) {
                var data = [];

                for (i = 0; i < response.data.result.length; i++) {
                    var reference_no = response.data.result[i]["reference_no"];
                    var date = response.data.result[i]["date"];
                    var scale_calibration_id = response.data.result[i]["scale_calibration_id"];
                    var factory = response.data.result[i]["factory"];
                    var description = response.data.result[i]["description"];
                    var path = response.data.result[i]["path"];
                    var pathF = "'" + path + "'";
                    data.push({
                        "Reference No": reference_no,
                        Factory: factory,
                        Description: description,
                        Date: date,
                        edit:
                            '<button class="btn btn-primary" onclick="edit(' +
                            scale_calibration_id +
                            ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
                        view:
                            '<button class="btn btn-success" onclick="viewAttachment(' +
                            pathF +
                            ')"><i class="fa fa-eye" aria-hidden="true"></i></button>',
                        delete:
                            '<button class="btn btn-danger" onclick="_delete(' +
                            scale_calibration_id +
                            ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
                    });
                }

                var table = $("#myTable").DataTable();
                table.clear();
                table.rows.add(data).draw();
            }
        },

        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}

function saveScaleCalibrationRecord() {
    swal({
        title: "Are you sure want to approve",
        icon: "warning",
        buttons: {
            confirm: {
                text: "Yes",
                visible: true,
                value: true,
                className: "btn btn-primary",
                closeModal: true,
            },
            cancel: {
                text: "No",
                visible: true,
                value: false,
                className: "btn btn-danger bg-danger",
                closeModal: true,
            }
        }
    }).then((value) => {
        if (value == true) {
            $.ajax({
                type: "POST",
                url: "/qc/ScaleCalibrationController/save",
                data: {
                    reference_no: $("#reference_no").val(),
                    date: $("#date").val(),
                    factory: $("#factory").val(),
                    description: $("#description").val(),
                    attachment_token: $("#attachment_token").val(),
                },
                headers: {
                    "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
                },
                timeout: 800000,
                beforeSend: function () { },
                success: function (response) {
                    console.log(response);
                    if (response.data.success) {
                        allScaleCalibrationRecords();
                        clearDropzone();
                        $("#file_input").val("");
                        $("#scale_calibration_id").val("");
                        $("#attachment_token").val(Date.now().toString());
                        $("#reference_no").val("");
                        $("#date").val("");
                        $("#factory").val("");
                        $("#description").val("");
                        toastr.success("data saved");
                    } else {
                        showErrorMessage();
                    }
                },
                error: function (error) {
                    console.log(error);
                    toastr.error("Something went wrong");
                },
                complete: function () { },
            });
        }
    });
}

function updateScaleCalibrationRecord(scale_calibration_id) {
    swal({
        title: "Are you sure want to approve",
        icon: "warning",
        buttons: {
            confirm: {
                text: "Yes",
                visible: true,
                value: true,
                className: "btn btn-primary",
                closeModal: true,
            },
            cancel: {
                text: "No",
                visible: true,
                value: false,
                className: "btn btn-danger bg-danger",
                closeModal: true,
            }
        }
    }).then((value) => {
        if (value == true) {
            $.ajax({
                type: "PUT",
                url: "/qc/ScaleCalibrationController/update/" + scale_calibration_id,
                data: {
                    reference_no: $("#reference_no").val(),
                    date: $("#date").val(),
                    factory: $("#factory").val(),
                    description: $("#description").val(),
                    attachment_token: $("#attachment_token").val(),
                },
                headers: {
                    "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
                },
                timeout: 800000,
                beforeSend: function () { },
                success: function (response) {
                    console.log(response);
                    if (response.data.success) {
                        allScaleCalibrationRecords();
                        clearDropzone();
                        $("#btnModalSave").text("Save");
                        $("#file_input").val("");
                        $("#attachment_token").val(Date.now().toString());
                        $("#scale_calibration_id").val("");
                        $("#reference_no").val("");
                        $("#date").val("");
                        $("#factory").val("");
                        $("#description").val("");
                        toastr.success("data updated");
                    } else {
                        showErrorMessage();
                    }
                },
                error: function (error) {
                    console.log(error);
                    toastr.error("Something went wrong");
                },
                complete: function () { },
            });
        }
    });

}

function edit(id) {
    scale_calibration_id = id;
    getScaleCalibrationData(id);
    $("#btnModalSave").text("Update");
    $("#attachmentAddModal").modal("toggle");
}

function getScaleCalibrationData(id) {
    $.ajax({
        type: "GET",
        url: "/qc/ScaleCalibrationController/getScaleCalibrationData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            $("#reference_no").val(res.reference_no);
            $("#date").val(res.date);
            $("#factory").val(res.factory);
            $("#description").val(res.description);
            $("#attachment_token").val(res.token);
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function view(id) {
    location.href = "/qc/scaleCalibration?id=" + id + "&action=view";
}

function _delete(id) {
    showAlert("Are You Sure?", id);
}

function showAlert(message, id) {
    swal({
        title: message,
        text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        dangerMode: true,
        buttons: {
            cancel: {
                text: "Cancel",
                visible: true,
                value: false,
                closeModal: true,
            },
            confirm: {
                text: "Ok",
                visible: true,
                value: true,
                closeModal: true,
            }
        }
    }).then((value) => {
        if (value == true) {
            $.ajax({
                type: "DELETE",
                headers: {
                    "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
                },
                url: "/qc/ScaleCalibrationController/delete/" + id,
                success: function (response) {
                    console.log(response);
                    allScaleCalibrationRecords();
                },
                error: function (data) {
                    console.log(data);
                },
            });
        }
    });
}

function getFactoryData() {
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getFactoryData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#factory").append(
                    '<option value="' +
                    res[i].site_id +
                    '">' +
                    res[i].site +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}



function viewAttachment(file) {
    window.open('/scale_calibration/' + file);
}

/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
